#ifndef ASTRO_H
#define ASTRO_H 1

#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <list>
#include <cmath>

#include "nehe.h"

#define ESCALA 15.0f // Escala de Posicin
#define ESCALA_RADIO 5.0f // Escala de Radio
#define RADIO_SOL 10 * 1.392f // Radio del Sol
#define RADIO_LUNA 2 * 0.1737f // Radio de la Luna


using namespace std;

class Astro
{        
      public:
         GLfloat *_tiempo;
         GLuint *_textura;
         GLUquadricObj *quadratic;
         GLfloat _radio;
         Astro() { _textura = (GLuint *)malloc(sizeof(GLuint)); _radio = 0.0f;};
         virtual ~Astro() { free(_textura); };
         virtual GLfloat posicionX()=0;
         virtual GLfloat posicionY()=0;
         virtual GLfloat posicionZ()=0;
         virtual GLvoid graficar()=0;
         virtual GLvoid trayectoria(){};
       
};

#endif
