#ifndef PLANETA_H
#define PLANETA_H 1


#include "astro.h"
#include "satelite.h"

class Planeta:public Astro
{
      protected:
         GLfloat _radio;
         GLfloat _horas_dia;
         GLfloat _horas_orbita;
         GLfloat _inclinacion;
         GLfloat _perihelio;
         GLfloat _afelio;
         GLfloat _puntos_trayectoria[32][4];
         list<Satelite *> lunas;
         
      public:
         Planeta(GLfloat radio, GLfloat *tiempo, GLUquadricObj *quad)
         { _radio = ESCALA_RADIO * radio; _tiempo = tiempo; quadratic = quad;
         };
         
         void calcularTrayectoria()
         {
              GLfloat x, y, z, angulo;
              for (int i = 1; i <= 32; i++)
              {
                  angulo = 2.0 * 3.1415f / 32;
                  x = (ESCALA * this->_afelio + RADIO_SOL) * cos(i * angulo);
                  y = (ESCALA * this->_perihelio + RADIO_SOL) * sin(i * angulo);
                  z = 0.0f;
                  _puntos_trayectoria[i-1][0] = x;
                  _puntos_trayectoria[i-1][1] = y;
                  _puntos_trayectoria[i-1][2] = z;
                      
              }
         };
         
         virtual GLfloat posicionX(){
               GLfloat w = 2.0 * 3.1415f / (this->_horas_orbita);
               GLfloat angulo = *(this->_tiempo) * w;
               GLfloat pos = (ESCALA * this->_afelio + RADIO_SOL) * cos(angulo); // 1.496
               return pos;      
         };
         virtual GLfloat posicionY(){
                GLfloat w = 2.0 * 3.1415f / (this->_horas_orbita);
                GLfloat angulo = *(this->_tiempo) * w;
                GLfloat pos = (ESCALA * this->_perihelio + RADIO_SOL) * sin(angulo);
                return pos;      
         };
         virtual GLfloat posicionZ(){
                 return 0.0f; 
         };
         virtual GLvoid graficar(){
                 glEnable(GL_TEXTURE_2D);
                 glBindTexture(GL_TEXTURE_2D, *(this->_textura));
                 glPushMatrix();
                                glTranslatef(this->posicionX(), this->posicionY(), this->posicionZ());
                                GLfloat LightPos[] = {-this->posicionX(), -this->posicionY(), -this->posicionZ()};
                                glLightfv(GL_LIGHT1, GL_POSITION, LightPos );
                                glRotatef(this->rotacion(), 0.0f, 0.0f, 1.0f);
                                glRotatef(this->inclinacion(), -1.0, 0.0f, 0.0f);
                                gluSphere(this->quadratic, this->_radio, 32, 32);
                                
                                list<Satelite *>::iterator iterador;
                                           for (iterador = lunas.begin(); iterador != lunas.end(); iterador++)
                                           (*iterador)->graficar();
                 glPopMatrix();      
                 glDisable(GL_TEXTURE_2D); 
                 };
                 
         GLfloat rotacion(){
                 GLfloat w = 3.1415f / (this->_horas_dia);
                 GLfloat angulo = w * *(this->_tiempo);
                 return angulo; };
                 
         GLfloat inclinacion(){ return _inclinacion; };
         
         GLvoid trayectoria(){
                //glDisable(GL_LIGHTING);
                glLineWidth(2.0f);
   //             glColor3f(0.47f, 0.633f, 1.0f);
  //             glClearColor(0.1f, 0.1f, 0.1f, 0.0f);
                glBegin(GL_LINE_LOOP);
                  for (int i = 0; i < 32; i++)
                      glVertex3fv(&this->_puntos_trayectoria[i][0]);
                glEnd();
                //glEnable(GL_LIGHTING);     
         };
         
       
       
};

#endif
