#ifndef SOLAR_H
#define SOLAR_H 1

#include "sistema.h"
#include "sol.h"
#include "saturno.h"
#include "marte.h"
#include "tierra.h"
#include "jupiter.h"
#include "venus.h"
#include "mercurio.h"
#include "urano.h"
#include "neptuno.h"
#include "pluton.h"

class Solar:public Sistema
{        
      public:
         
         Solar(GLfloat *tiempo, GLUquadricObj *quad);
         ~Solar();
         GLfloat posicionX();
         GLfloat posicionY();
         GLfloat posicionZ();
         GLvoid graficar();
         GLvoid trayectorias();
       
};

inline Solar::Solar(GLfloat *tiempo, GLUquadricObj *quad):Sistema(tiempo, quad)
{
       GLfloat ampli = 10.0f;
       centro = new Sol(RADIO_SOL, 1.0f, 1.0f, 1.0f, 1.0f, this->_tiempo, this->quadratic);
       astros.push_front(new Tierra(0.012f*ampli, this->_tiempo, this->quadratic));
       astros.push_front(new Marte(0.006f*ampli, this->_tiempo, this->quadratic));
       astros.push_front(new Saturno(0.120f*ampli, this->_tiempo, this->quadratic));
       astros.push_front(new Jupiter(0.142f*ampli, this->_tiempo, this->quadratic));
       astros.push_front(new Venus(0.012f*ampli, this->_tiempo, this->quadratic));
       astros.push_front(new Mercurio(0.004f*ampli, this->_tiempo, this->quadratic));
       astros.push_front(new Urano(0.051f*ampli, this->_tiempo, this->quadratic));
       astros.push_front(new Neptuno(0.049f*ampli, this->_tiempo, this->quadratic));
       astros.push_front(new Pluton(0.02f*ampli, this->_tiempo, this->quadratic));
}

inline GLfloat Solar::posicionX()
{
       return centro->posicionX();     
}

inline GLfloat Solar::posicionY()
{
       return centro->posicionY();     
}

inline GLfloat Solar::posicionZ()
{
       return centro->posicionZ();     
}

inline GLvoid Solar::graficar()
{
       glPushMatrix();
             glTranslatef(this->posicionX(), this->posicionY(), this->posicionZ());
             centro->graficar();
             list<Astro *>::iterator iterador;
             for (iterador = astros.begin(); iterador != astros.end(); iterador++)
             {
                  
                 (*iterador)->graficar();
             }
       glPopMatrix();       
}

inline GLvoid Solar::trayectorias()
{
       glPushMatrix();
             glTranslatef(this->posicionX(), this->posicionY(), this->posicionZ());
             centro->graficar();
             list<Astro *>::iterator iterador;
             for (iterador = astros.begin(); iterador != astros.end(); iterador++)
             {
                 (*iterador)->trayectoria();
             }
       glPopMatrix();       
}
#endif
